<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'FaultType' => '\\StructType\\FaultType',
            'FaultContextType' => '\\StructType\\FaultContextType',
            'FaultDetailsType' => '\\StructType\\FaultDetailsType',
            'Data' => '\\StructType\\Data',
            'FaultListType' => '\\StructType\\FaultListType',
            'PayloadType' => '\\StructType\\PayloadType',
            'LoanOffsetInputType' => '\\StructType\\LoanOffsetInputType',
            'LoanOffsetOutputType' => '\\StructType\\LoanOffsetOutputType',
            'RequestHeaderType' => '\\StructType\\RequestHeaderType',
            'ResponseHeaderType' => '\\StructType\\ResponseHeaderType',
            'CredentialsType' => '\\StructType\\CredentialsType',
            'StatusMessagesType' => '\\StructType\\StatusMessagesType',
            'operationRequest' => '\\StructType\\OperationRequest',
            'operation1Request' => '\\StructType\\Operation1Request',
            'operation1Response' => '\\StructType\\Operation1Response',
            'operationRequest1' => '\\StructType\\OperationRequest1',
            'operationResponse' => '\\StructType\\OperationResponse',
            'operationRequest2' => '\\StructType\\OperationRequest2',
            'operationResponse1' => '\\StructType\\OperationResponse1',
            'RuntimeContextType' => '\\StructType\\RuntimeContextType',
        );
    }
}
